#include "Utils_eigne.h"
#include "postprocess_class.h"

typedef float T;

////////////////// post process function  ////////////////////
PredOut<T> postprocess_func(std::vector<float*> outputDataVec){
    //post process variables
    ClsScores<T> c1;
    BboxPreds<T> b1;
    DirClsPreds<T> d1;
    AttrPreds<T> a1;
    Centerness<T> ce1;

    //fill tensors for postprocessing
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(0), c1.scrs[0]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(1), c1.scrs[1]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(2), c1.scrs[2]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(3), c1.scrs[3]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(4), c1.scrs[4]);

    fill_tensor_from_onnx_output_tensor(outputDataVec.at(5), b1.bboxes[0]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(6), b1.bboxes[1]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(7), b1.bboxes[2]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(8), b1.bboxes[3]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(9), b1.bboxes[4]);

    fill_tensor_from_onnx_output_tensor(outputDataVec.at(10), d1.dirs[0]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(11), d1.dirs[1]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(12), d1.dirs[2]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(13), d1.dirs[3]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(14), d1.dirs[4]);

    fill_tensor_from_onnx_output_tensor(outputDataVec.at(15), a1.attr[0]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(16), a1.attr[1]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(17), a1.attr[2]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(18), a1.attr[3]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(19), a1.attr[4]);

    fill_tensor_from_onnx_output_tensor(outputDataVec.at(20), ce1.centers[0]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(21), ce1.centers[1]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(22), ce1.centers[2]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(23), ce1.centers[3]);
    fill_tensor_from_onnx_output_tensor(outputDataVec.at(24), ce1.centers[4]);

    PostProcessFcos3D<T> stage1;
    std::cout << "Run main pipeline...\n";
    PredOut<T> results = stage1.predict(c1, b1, d1, a1, ce1);

return results;
}
